#include <png.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <assert.h>
#include "pngimg.h"

//#define DX 8
//#define DY 6

#define DX subsample_x
#define DY subsample_y

#define GET_BIF(bifs, x,y)  (&(bifs->b)[(x)+(y)*(bifs->w)])

#define INFTY 100000000000LL

#define ARGVS_SIZ 1024
char argvs [ARGVS_SIZ+1];

int subsample_x = 4;
int subsample_y = 3;
int do_unique = 0;
int do_png = 0;
int border = 1;
int img_must_have_id = -1;
char *img_must_have = NULL;

int small_size_w = 0;
int small_size_h = 0;


typedef struct t_bif {
	double dist;
	int img_no;
	int round; // v kterem kole byla acceptnuta
} t_bif;

typedef struct t_bifs {
	int w, h;
	t_bif *b;
} t_bifs;

typedef struct t_img_list {
	char *name;
	double dist;
	int round;
	int bestin;
} t_img_list;

#define HTML_HEAD \
	"<html>\n" \
	"<head>\n" \
	"<title>obrazek z obrazku pikomatu</title>\n" \
	"<style>\n" \
	"a{\n" \
	"\tmargin:0px; padding:0px;}\n" \
	"img{\n" \
	"\tmargin:0px 0px 1px 1px;\n" \
	"\tpadding:0px;\n" \
	"\tborder-width: 0px;\n" \
	"\tborder-color: #000}\n" \
	"div{\n" \
	"\tbackground:#000;\n" \
	"\tfloat:left;\n" \
	"\tborder-style:solid;\n" \
	"\tborder-color:#000;\n" \
	"\tborder-width:1px 1px 0px 0px;}\n" \
	"</style>\n" \
	"</head>\n" \
	"<body><div>\n" 

#define HTML_BODY "<a href=\"%s/%s\"><img\nsrc=\"%s/%s\"/></a>"

#define HTML_END "</div>\n</body>\n</html>\n"


#define HTML_MAP_HEAD \
	"<html>\n" \
	"<head>\n" \
	"<title>obrazek z obrazku pikomatu</title>\n" \
	"<body>\n" \
	"<a href=\"%s.png\">img only</a>%s\n" \
	"<p><OBJECT data=\"%s.png\" type=\"image/png\" usemap=\"#map\"></object></p>\n" \
	"<map name=map>\n"
#define HTML_MAP "</map>\n</body>\n</html>\n"
#define HTML_MAP_BODY "<area href=\"%s/%s\" shape=\"rect\" coords=\"%i,%i,%i,%i\"/>\n"




char *list; 
char *in_png;
char *in_dir;
char *output_name;
char *big_dir;
t_img_list *img_list;
int img_list_top;

/*
 * img1 -- big img
 * img2 -- small tryying to fit
 */
void
try_one(t_img *img1, t_img *img2, t_bifs* bifs, int img_no, int round)
{
	double dist;
	int dx, dy;
	int x, y;
	dx = DX;
	dy = DY;
	img_avg(img2, dx, dy);
	t_bif *b;

	for(x = 0; x + dx <= img1->w; x+= dx) 
	for(y = 0; y + dy <= img1->h; y+= dy) 
	{
		b = GET_BIF(bifs, x/dx, y/dy);
		if( b->round > 0 && b->round < round ) {
			continue;
		}
		dist = img_dist(img1, img2, x, y, dx, dy);
		//printf("%i, %i\n", x/dx, y/dy);
		if( dist <  b->dist  ) {
			assert(img_no < img_list_top);
			b->dist = dist;
			b->img_no = img_no;
			b->round = round;
		}
	}

} /* try_one */

#define PATH_MAX 1024
#define IMGS_MAX 512
#define IMGNAME_MAX PATH_MAX


void
read_list(char *listname)
{
	int img_size = IMGS_MAX;
	int len;
	char name[IMGNAME_MAX + 1];
	FILE *file;

	img_list_top = 0;
	img_list = (t_img_list*)malloc(sizeof(t_img_list)*img_size);

	if( img_list == NULL ) {
		printf("cannt malloc img_list\n");
		exit(-1);
	}

	file = fopen(listname, "rt");
	if( file == NULL ) {
		printf("cannt open('%s')\n", listname);
		exit(-1);
	}

	while(fgets(name, IMGNAME_MAX, file)) {
		if( img_list_top >= img_size ) {
			img_size *= 2;

			img_list = (t_img_list*)realloc(
						img_list, sizeof(t_img_list)*img_size);
			if( img_list == NULL ) {
				printf("cannt remalloc img_list\n");
				exit(-1);
			}
		}

		len = strlen(name);
		if( len > 0 && name[len-1] == '\n' ) {
			name[len-1] = '\0';
		}
		if( img_must_have && 0 == strcmp(img_must_have, name) ) {
			img_must_have_id = img_list_top;
		}

		img_list[img_list_top].name = strdup(name);
		img_list[img_list_top].round = 0;
		img_list[img_list_top].dist = 0;
		img_list_top++;
	}
	if( img_must_have && img_must_have_id < 0 ) {
		img_must_have_id = img_list_top;
		img_list[img_list_top].name = strdup(img_must_have);
		img_list[img_list_top].round = 0;
		img_list[img_list_top].dist = 0;
		img_list_top++;
		printf("war: musthave img was not in list (but don't worry)\n");
	}

} /* read_list */

t_bifs*
create_bifs(t_img *img)
{
	t_bifs * bifs;
	int i;

	bifs = malloc(sizeof(t_bifs));

	bifs->w = img->w / DX;
	bifs->h = img->h / DY;
	bifs->b = malloc(bifs->w * bifs->h * sizeof(t_bif));

	for(i =0; i< bifs->w*bifs->h; i++ ) {
		bifs->b[i].dist = INFTY;
		bifs->b[i].round = 0;
		bifs->b[i].img_no = 0;
	}

	return bifs;
}

void
bifs_write_png(t_bifs *bifs, char *basename)
{
	FILE *file;
	int x, y;
	t_bif *b;
	char filename[ IMGNAME_MAX ];
	int sw = small_size_w + border;
	int sh = small_size_h + border;
	t_img *img, *img2;


	img = img_create( border + sw  * bifs->w, border + sh * bifs->h, 8);
	printf("img: w%i h%i\n", img->w, img->h);
	//printf("sw%i sh%i\n", sw, sh);
	//printf("bw%i bh%i\n", bifs->w, bifs->h);

	for(y = 0; y < bifs->h; y++)
	{
		assert(y < bifs->h);
		for(x = 0; x < bifs->w; x++){
			assert(x < bifs->w);
			b = GET_BIF(bifs, x, y);
			snprintf(filename, IMGNAME_MAX,
				"%s/%s", in_dir, img_list[b->img_no].name);
			//printf("%i,%i:%s\n", x, y, filename);

			img2 = img_load(filename);

			assert(img2->w == sw -border);
			assert(img2->h == sh -border);

			img_cpy(img2, img, border + sw * x, border +sh * y); 
			img_free(img2);
		}
	}

	snprintf(filename, IMGNAME_MAX, "%s.png", basename);
	img_save(img, filename);
	img_free(img);
	printf("saved in '%s'\n", filename);
} /* bifs_write_png */

void
bifs_write(t_bifs *bifs, char *basename)
{
	FILE *file;
	int x, y;
	t_bif *b;
	int sw = small_size_w + border;
	int sh = small_size_h + border;
	char filename[ IMGNAME_MAX +1];

	snprintf(filename, IMGNAME_MAX, "%sq.html", basename);

	file = fopen(filename, "w");
	if( file == NULL ) {
		printf("cannt open(%s)\n", filename);
		exit(-1);
	}
	fprintf(file, "<!--%s-->", argvs);
	fprintf(file, "%s", HTML_HEAD);
	for(y = 0; y < bifs->h; y++)
	{
		assert(y < bifs->h);
		for(x = 0; x < bifs->w; x++)
		{
			assert(x < bifs->w);
			b = GET_BIF(bifs, x, y);
			assert(b->img_no < img_list_top);
			fprintf(file, HTML_BODY,
				big_dir,
				img_list[b->img_no].name,
				in_dir,
				img_list[b->img_no].name);
		}
		fprintf(file, "<br/>\n");
	}
	fprintf(file, HTML_END);
	fclose(file);
	printf("output writen to: '%s'\n", filename);
} /* bifs_write_png */

void
bifs_write_map(t_bifs *bifs, char *basename)
{
	FILE *file;
	int x, y;
	t_bif *b;
	int sw = small_size_w + border;
	int sh = small_size_h + border;
	char filename[ IMGNAME_MAX +1];

	snprintf(filename, IMGNAME_MAX, "%s.html", basename);

	file = fopen(filename, "w");
	if( file == NULL ) {
		printf("cannt open(%s)\n", filename);
		exit(-1);
	}
	fprintf(file, "<!--%s-->", argvs);
	fprintf(file, HTML_MAP_HEAD, basename, argvs, basename);
	for(y = 0; y < bifs->h; y++)
	{
		assert(y < bifs->h);
		for(x = 0; x < bifs->w; x++)
		{
			assert(x < bifs->w);
			b = GET_BIF(bifs, x, y);
			assert(b->img_no < img_list_top);
			fprintf(file, HTML_MAP_BODY,
				big_dir,
				img_list[b->img_no].name,
				border + x * sw,
				border + y * sh,
				(x+1) * sw -1 ,
				(y+1) * sh -1);
		}
	}
	fprintf(file, HTML_END);
	fclose(file);
	printf("output writen to: '%s'\n", filename);
} /* bifs_write_map */

void
try_test_size(t_img *img, char *filename)
{
	if( small_size_w == 0 ){
		small_size_w = img->w;
		small_size_h = img->h;
		return;
	}
	if( small_size_w != img->w ) {
		printf("%s->w(%i) is not %i\n", filename, small_size_w, img->w);
		exit(-1);
	}
	if( small_size_h != img->h ) {
		printf("%s->h(%i) is not %i\n", filename, small_size_h, img->h);
		exit(-1);
	}
} /* try_test_size */

void
try_all_one_i(t_img *big, t_bifs *bifs, int i, int round)
{
	char inname[IMGS_MAX+1];
	t_img *small;

	printf("\r%i of %i    ", i, img_list_top);
	fflush(stdout);
	snprintf(inname, IMGS_MAX, "%s/%s", in_dir, img_list[i].name);
	small = img_load(inname);
	try_test_size(small, inname);
	if( small == NULL ) {
		printf("error reading %i. image: '%s'\n", i, inname);
		exit(-1);
	}
	try_one(big, small, bifs, i, round);
	img_free(small);
}

void
try_all_round(t_img *big, t_bifs *bifs, int round)
{
	int i;
	for( i=0; i < img_list_top; i++) {
		if( img_list[i].round > 0  ) {
			continue;
		}
		try_all_one_i(big, bifs, i, round);
	}
} /* try_all_round */

int
try_accept(t_bifs *bifs, int round)
{
	int i, no;
	t_bif *b;
	int count =0;
	int done =0;
	int all =  bifs->w * bifs->h;
	for(i = all;  i--;) {
		b = &bifs->b[i];
		if( b->round == round ) {
			no = b->img_no;
			assert(no < img_list_top);
			assert(img_list[no].round ==0 || img_list[no].round ==round);
			if( img_list[no].round  == 0  ) {
				img_list[no].round  = round;
				img_list[no].dist = b->dist;
				img_list[no].bestin = i;
			}
			else if( b->dist < img_list[no].dist ) {
				img_list[no].dist = b->dist;
				img_list[no].bestin = i;
			}
			b->round = 0;
			b->dist = INFTY;
		}
		else if( b->round > 0 ) {
			done ++;
		}
	}
	for(i = img_list_top; i -- ; ) {
		if( img_list[i].round == round ) {
			count++;
			bifs->b[ img_list[i].bestin ].round = round;
		}
	}
	printf("in round %i accpted %i images of %i(left:%i)\n",
		round, count, bifs->w * bifs->h, all - done - count);
	return all - done - count;
} /* try_accept */

void
try_all(char *imgname, char *listname)
{
	t_img *big;
	int len;
	FILE *list;
	t_bifs * bifs;
	int i;
	int round = 0;

	big = img_load(imgname);
	if( big == NULL ) {
		printf("error reading '%s'", imgname);
		exit(-1);
	}

	bifs = create_bifs(big);

	read_list(listname);
	
	if( img_must_have != NULL ) {
		try_all_one_i(big, bifs, img_must_have_id, ++round);
		try_accept(bifs, round);
	}

	if( do_unique ) {
		for( i = 0; i < 10; i++ ) {
			try_all_round(big, bifs,++round);
			try_accept(bifs, round);
		}
	}
	else {
		try_all_round(big, bifs,++round);
		printf("\n");
	}


	if( do_png ) {
		bifs_write_png(bifs, output_name);
		bifs_write_map(bifs, output_name);
	} else {
		bifs_write(bifs, output_name);
	}
} /* try_all */


void
mem_leak_test()
{
	int i = 1;
	t_img *img;
	printf("memleak test...\n");
	while(i++) {
		printf("\r%i   ", i);
		fflush(stdout);
		img = (t_img*)malloc(sizeof(t_img));
		if( (img = img_load("a.png")) == NULL) {
			exit(-1);
		}
		img_free(img);
	}
}

int
test()
{
	int w, h;
	int x,y;
	int i;
	png_bytepp rows;
	int rc;
	t_img *img;
	t_img *img2;

	img = img_load("a.png");

	h = img->h;
	w = img->w;

	if( img == NULL )  {
		printf("error %i ocured while opening png");
		exit(-1);
	}

	printf("w: %i h: %i dep: %i\n", img->w, img->h, img->dep);

	img2 = img_create(img->w* 2, img->h *2, 8);
	img_cpy(img,img2,10,10);
	img_save(img2, "b.png");

	
	return;

	for(x = 0; x < w; x++) {
		for(y=0; y < h ; y++) {
			img->rows[y][x*img->dep] = 0;
		}
	}

	printf("and now...\n");
	img->rows[479][650] = 0;

	if( 0 ) {
		mem_leak_test();
	}




	return 0;
}

int
usage()
{
	printf("usage: piart\n");
	printf("\t[-l img-list(=%s)]\n", list);
	printf("\t[-d indir(=%s)]\n", in_dir);
	printf("\t[-i inpng(=%s)]\n", in_png);
	printf("\t[-o output w/o ext (=%s)]\n", output_name);
	printf("\t[-b big-dir(=%s)]\n", big_dir);
	printf("\t[-x N(=%i)] [-y N(=%i)]\n", DX, DY);
	printf("\t[-u] unique (try not repeat)\n");
	printf("\t[-p] do one big png\n");
	printf("\t[-B N] border size (=%i)\n", border);
	printf("\t[-m img] result must have this img (=none)\n");
	printf("\n");
}


void 
save_argv(int argc, char *argv[])
{
	int i;
	char *s = &argvs[0];
	int size = ARGVS_SIZ; 
	int count;
	argvs[ARGVS_SIZ] = '\0';

	for(i = 0; i <  argc; i++) {
		count = snprintf(s, size, "%s ", argv[i]);
		s += count;
		size -= count;
		if( size <= 0 ) {
			return;
		}
	}
}

int
main(int argc, char *argv[])
{
	int z;

	save_argv(argc, argv);

	list = "list";
	in_png = "in.png";
	in_dir = "png24x18";
	big_dir = "png640x480";
	output_name = "out";

	if( argc <= 1 ) {
		usage();
		return(0);
	}

	while( -1 != (z = getopt(argc, argv, "m:B:l:b:d:i:o:x:yupth")) ) {
		switch(z){
		case 'b': big_dir = optarg; break;
		case 'B': border = atoi(optarg); break;
		case 'd': in_dir = optarg; break;
		case 'o': output_name = optarg; break;
		case 'l': list = optarg; break;
		case 'i': in_png = optarg; break;
		case 'x': subsample_x = atoi(optarg); break;
		case 'y': subsample_y = atoi(optarg); break;
		case 'u': do_unique++; break;
		case 'p': do_png++; break;
		case 'm': img_must_have = optarg; break;
		case 'h': usage(); return 0; break;
		case 't': test(); return 1; break;
		default:
			usage();
			return -1;
		}
	}

	assert(subsample_x);
	assert(subsample_y);

	try_all(in_png, list);
	return 0;
}

// vi:nocin
